diff options
author | Denis Vlasenko <vda.linux@googlemail.com> | 2007-03-07 22:02:23 +0000 |
---|---|---|
committer | Denis Vlasenko <vda.linux@googlemail.com> | 2007-03-07 22:02:23 +0000 |
commit | ab9eef21a57c23567505e8fbceb8e5ea76306ce1 (patch) | |
tree | 800845b64d0e9a204743656c4d267cc6c9917cde /testsuite/bunzip2.tests | |
parent | 8e858e2700651a0e973169b579622cd3dcd0defd (diff) | |
download | busybox-w32-ab9eef21a57c23567505e8fbceb8e5ea76306ce1.tar.gz busybox-w32-ab9eef21a57c23567505e8fbceb8e5ea76306ce1.tar.bz2 busybox-w32-ab9eef21a57c23567505e8fbceb8e5ea76306ce1.zip |
bunzip2/gunzip/uncompress/unlzma: merge into common code -
fix few corner cases, reduce size by 450 bytes. Update testsuite.
Diffstat (limited to 'testsuite/bunzip2.tests')
-rwxr-xr-x | testsuite/bunzip2.tests | 84 |
1 files changed, 84 insertions, 0 deletions
diff --git a/testsuite/bunzip2.tests b/testsuite/bunzip2.tests new file mode 100755 index 000000000..83c365d75 --- /dev/null +++ b/testsuite/bunzip2.tests | |||
@@ -0,0 +1,84 @@ | |||
1 | #!/bin/sh | ||
2 | |||
3 | if test "${0##*/}" = "gunzip.tests"; then | ||
4 | unpack=gunzip | ||
5 | ext=gz | ||
6 | elif test "${0##*/}" = "bunzip2.tests"; then | ||
7 | unpack=bunzip2 | ||
8 | ext=bz2 | ||
9 | else | ||
10 | echo "WTF? argv0='$0'" | ||
11 | exit 1 | ||
12 | fi | ||
13 | |||
14 | bb="busybox " | ||
15 | |||
16 | unset LC_ALL | ||
17 | unset LC_MESSAGES | ||
18 | unset LANG | ||
19 | unset LANGUAGE | ||
20 | |||
21 | hello_gz() { | ||
22 | # Gzipped "HELLO\n" | ||
23 | #_________________________ vvv vvv vvv vvv - mtime | ||
24 | echo -ne "\x1f\x8b\x08\x00\x85\x1d\xef\x45\x02\x03\xf3\x70\xf5\xf1\xf1\xe7" | ||
25 | echo -ne "\x02\x00\x6e\xd7\xac\xfd\x06\x00\x00\x00" | ||
26 | } | ||
27 | |||
28 | hello_bz2() { | ||
29 | # Bzipped "HELLO\n" | ||
30 | echo -ne "\x42\x5a\x68\x39\x31\x41\x59\x26\x53\x59\x5b\xb8\xe8\xa3\x00\x00" | ||
31 | echo -ne "\x01\x44\x00\x00\x10\x02\x44\xa0\x00\x30\xcd\x00\xc3\x46\x29\x97" | ||
32 | echo -ne "\x17\x72\x45\x38\x50\x90\x5b\xb8\xe8\xa3" | ||
33 | } | ||
34 | |||
35 | prep() { | ||
36 | rm -f t* | ||
37 | hello_$ext >t1.$ext | ||
38 | hello_$ext >t2.$ext | ||
39 | } | ||
40 | |||
41 | check() { | ||
42 | eval $2 >t_actual 2>&1 | ||
43 | if echo -ne "$expected" | cmp - t_actual; then | ||
44 | echo "$1: PASS" | ||
45 | else | ||
46 | echo "$1: FAIL" | ||
47 | fi | ||
48 | } | ||
49 | |||
50 | mkdir testdir 2>/dev/null | ||
51 | ( | ||
52 | cd testdir || { echo "cannot cd testdir!"; exit 1; } | ||
53 | |||
54 | expected="$unpack: z: No such file or directory | ||
55 | 1 | ||
56 | HELLO | ||
57 | " | ||
58 | prep; check "$unpack: doesnt exist" "${bb}$unpack z t1.$ext; echo \$?; cat t1" | ||
59 | |||
60 | |||
61 | expected="$unpack: t.zz: unknown suffix - ignored | ||
62 | 1 | ||
63 | HELLO | ||
64 | " | ||
65 | prep; >t.zz; check "$unpack: unknown suffix" "${bb}$unpack t.zz t1.$ext; echo \$?; cat t1" | ||
66 | |||
67 | |||
68 | # In this case file "t1" exists, and we skip t1.gz and unpack t2.gz | ||
69 | expected="$unpack: t1: File exists | ||
70 | 1 | ||
71 | HELLO | ||
72 | " | ||
73 | prep; >t1; check "$unpack: already exists" "${bb}$unpack t1.$ext t2.$ext; echo \$?; cat t1 t2" | ||
74 | |||
75 | |||
76 | # From old testsuite | ||
77 | expected="HELLO\n0\n" | ||
78 | prep; check "$unpack: stream unpack" "cat t1.$ext | ${bb}$unpack; echo $?" | ||
79 | |||
80 | expected="ok\n" | ||
81 | prep; check "$unpack: delete src" "${bb}$unpack t2.$ext; test ! -f t2.$ext && echo ok" | ||
82 | |||
83 | ) | ||
84 | rm -rf testdir \ No newline at end of file | ||